package mutagen

import (
	"math/rand"
	"time"

	neuralnetwork "../../neuralnetwork"
)

type DummyMutagen struct {
	chance float64
}

func NewDummyMutagen(chance float64) (rm *DummyMutagen) {
	rm = &DummyMutagen{
		chance: chance,
	}
	return
}

func (rm *DummyMutagen) Mutate(network *neuralnetwork.NeuralNetwork) {
	rand.Seed(time.Now().UnixNano())
	for l := 1; l < network.LayerCount; l++ {
		randomized := rand.Float64()
		if randomized < rm.chance {
			r, c := network.Weights[l].Dims()
			for o := 0; o < 1; o++ {
				mutationRow := int(rand.Uint32()) % r
				mutationColumn := int(rand.Uint32()) % c
				weight := rand.NormFloat64()
				bias := rand.NormFloat64()
				network.Weights[l].Set(mutationRow, mutationColumn, weight)
				network.Biases[l].Set(mutationRow, 0, bias)
			}
		}
	}
}
